
/**
 * @fileoverview Math blocks for Blockly.
 *
 * This file is scraped to extract a .json file of block definitions. The array
 * passed to defineBlocksWithJsonArray(..) must be strict JSON: double quotes
 * only, no outside references, no functions, no trailing commas, etc. The one
 * exception is end-of-line comments, which the scraper will remove.
 * @author q.neutron@gmail.com (Quynh Neutron)
 */
'use strict';

//goog.provide('Blockly.Blocks.tortue');  // Deprecated
//goog.provide('Blockly.Constants.tortue');

goog.require('Blockly.Blocks');
goog.require('Blockly');



Blockly.defineBlocksWithJsonArray([  // BEGIN JSON EXTRACT
//Géométrie de la tortue (tortue 120)
//----------------------
//initialiser()
{
  "type": "tortue_initialisation",
  "message0": "initialisation",
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},

// avance(d)
{
  "type": "tortue_avance",
  "message0": "avance d'une distance %1",
  "args0": [
    {
      "type": "input_value",
      "name": "distance",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},

// recule(d)
{
  "type": "tortue_recule",
  "message0": "recule d'une distance %1",
  "args0": [
    {
      "type": "input_value",
      "name": "distance",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},

//droite(angle)
{
  "type": "tortue_droite",
  "message0": "tourne à droite de %1 degrés",
  "args0": [
    {
      "type": "input_value",
      "name": "alpha",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},
//gauche(angle)
{
  "type": "tortue_gauche",
  "message0": "tourne à gauche de %1 degrés",
  "args0": [
    {
      "type": "input_value",
      "name": "alpha",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},
// posX()
{
    "type": "tortue_posX",
    "message0": "coordonnée en x de la tortue",
    "output": "Number",
    "colour": 120,
    "tooltip": "",
    "helpUrl": ""
},
//posY()
{
    "type": "tortue_posY",
    "message0": "coordonnée en y de la tortue",
    "output": "Number",
    "colour": 120,
    "tooltip": "",
    "helpUrl": ""
},
//fixePos(x,y)
{
  "type": "tortue_fixePos",
  "message0": "aller au point ( %1 , %2 )",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},
//sautePos(x,y)
{
  "type": "tortue_sautePos",
  "message0": "sauter au point ( %1 , %2 )",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},
//cap()
{
    "type": "tortue_cap",
    "message0": "cap de la tortue",
    "output": "Number",
    "colour": 120,
    "tooltip": "",
    "helpUrl": ""
},
//fixeCap(angle)
{
  "type": "tortue_fixeCap",
  "message0": "fixer le cap à %1 ",
  "args0": [
    {
      "type": "input_value",
      "name": "ALPHA",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},
//vers(x,y)
{
  "type": "tortue_vers",
  "message0": "se tourner vers ( %1 , %2 )",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 120,
  "tooltip": "",
  "helpUrl": ""
},

//Crayon (crayon 80)
//------
//baisseCrayon()
{
  "type": "crayon_baisseCrayon",
  "message0": "baisser le crayon",
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},
//leveCrayon()
{
  "type": "crayon_leveCrayon",
  "message0": "lever le crayon",
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},
//fixeTailleCrayon(taille)
{
  "type": "crayon_fixeTailleCrayon",
  "message0": "taille du crayon %1",
  "args0": [
    {
      "type": "input_value",
      "name": "TAILLE",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},
//couleurCrayon(r,v,b)
{
  "type": "crayon_couleurCrayon",
  "message0": "couleur du crayon ( %1 , %2 , %3 )",
  "args0": [
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "V",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "B",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},
//couleurRemplissage(r,v,b,a)
{
  "type": "crayon_couleurRemplissage",
  "message0": "couleur de remplissage ( %1 , %2 , %3 , %4 )",
  "args0": [
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "V",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "B",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "A",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},
//debutRemplir()
{
  "type": "crayon_debutRemplir",
  "message0": "début de la description de la figure à remplir",
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},
//finRemplir()
{
  "type": "crayon_finRemplir",
  "message0": "fin de la description de la figure à remplir",
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 80,
  "tooltip": "",
  "helpUrl": ""
},

//Géométrie analytique (analytique 180)
//--------------------
//segment(x1,y1,x2,y2)
{
  "type": "analytique_segment",
  "message0": "segment par ( %1 , %2 ) et ( %3 , %4 )",
  "args0": [
    {
      "type": "input_value",
      "name": "X1",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y1",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "X2",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y2",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},
//cercle(x,y,r)
{
  "type": "analytique_cercle",
  "message0": "cercle de centre ( %1 , %2 ) et de rayon  %3",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},
//disque(x,y,r)
{
  "type": "analytique_disque",
  "message0": "disque de centre ( %1 , %2 ) et de rayon  %3",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},
//arc(x,y,r,a1,a2)
{
  "type": "analytique_arc",
  "message0": "arc de centre ( %1 , %2 ) et de rayon  %3 , allant de %4 à %5",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "A1",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "A2",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},
//ellipse(x,y,a,b)
{
  "type": "analytique_ellipse",
  "message0": "ellipse de centre ( %1 , %2 ) et de demi grands axes  %3 et %4",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "A",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "B",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},
//ellipseRemplie(x,y,a,b)
{
  "type": "analytique_ellipseRemplie",
  "message0": "ellipse remplie de centre ( %1 , %2 ) et de demi grands axes  %3 et %4",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "A",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "B",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},
//ecris(x,y,ligne1, ligne2, …)
{
  "type": "analytique_ecris",
  "message0": "texte positionné en ( %1 , %2 ): %3",
  "args0": [
    {
      "type": "input_value",
      "name": "X",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "Y",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "T",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 180,
  "tooltip": "",
  "helpUrl": ""
},

//Communication avec GeoGebra (geogebra 270)
//---------------------------

//tracerFigure()
{
  "type": "geogebra_tracerFigure",
  "message0": "tracer la figure",
  "previousStatement": null,
  "nextStatement": null,
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//retracerFigure()
{
  "type": "geogebra_retracerFigure",
  "message0": "retracer la figure",
  "previousStatement": null,
  "nextStatement": null,
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//nouveau(debut)
{
  "type": "geogebra_nouveau",
  "message0": "nouveau nom débutant par %1 ",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "output": "String",
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//commande(modele,listeNoms)
{
  "type": "geogebra_commande",
  "message0": "exécuter la commande %1 avec les paramètres %2",
  "args0": [
    {
      "type": "input_value",
      "name": "chaine",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "params",
      "check": "Array"
    }
  ],
  "inputsInline": false,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//valeur(nom)
{
  "type": "geogebra_valeur",
  "message0": "valeur de %1 ",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "output": "Number",
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//coordX(nom)
{
  "type": "geogebra_coordX",
  "message0": "coordonnée en x de %1 ",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "output": "Number",
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//coordY(nom)
{
  "type": "geogebra_coordY",
  "message0": "coordonnée en y de %1 ",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "output": "Number",
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//fixeValeur(nom,valeur)
{
  "type": "geogebra_fixeValeur",
  "message0": "donner à %1 la valeur %2",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "VAL",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},
//fixeCoords(nom,x,y)
{
  "type": "geogebra_fixeCoords",
  "message0": "donner à %1 les coordonnées ( %2 , %3 )",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "VAL1",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "VAL2",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},

//obtenirNomsDerniersObjets(n)
{
  "type": "geogebra_obtenirNomsDerniersObjets",
  "message0": "obtenirNomsDerniersObjets( %1 )",
  "args0": [
    {
      "type": "input_value",
      "name": "N",
      "check": "Number"
    }
  ],
  "output": "Array",
  "colour": 270,
  "tooltip": "",
  "helpUrl": ""
},

//Apparence --- Aspect des objets (divers 200)
//----------------
//cacheObjet(nom)
{
  "type": "apparence_cacheObjet",
  "message0": "cache %1",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//cacheEtiquette(nom)
{
  "type": "apparence_cacheEtiquette",
  "message0": "cache étiquette de %1",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//fixeObjet(nom)
{
  "type": "apparence_fixeObjet",
  "message0": "fixe l'objet %1",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//montreObjet(nom)
{
  "type": "apparence_montreObjet",
  "message0": "montre l'objet %1",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//montreEtiquette(nom)
{
  "type": "apparence_montreEtiquette",
  "message0": "montre l'étiquette de %1",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//libereObjet(nom)
{
  "type": "apparence_libereObjet",
  "message0": "libère l'objet %1",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//colorier(nom,R,V,B)
{
  "type": "apparence_colorier",
  "message0": "objet %1 de couleur ( %2 , %3 , %4 )",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "V",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "B",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//remplir(nom,R,V,B,A)
{
  "type": "apparence_remplir",
  "message0": "objet %1 rempli avec couleur ( %2 , %3 , %4 , %5 )",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "R",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "V",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "B",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "A",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//fixeEpaisseur(nom,taille)
{
  "type": "apparence_fixeEpaisseur",
  "message0": "fixe l'épaisseur de %1 à %2",
  "args0": [
    {
      "type": "input_value",
      "name": "NOM",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "EPAIS",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},
//changer aléatoirement les couleurs
{
  "type": "apparence_changerCouleurs",
  "message0": "Changer aléatoirement les couleurs",
  "previousStatement": null,
  "nextStatement": null,
  "colour": 200,
  "tooltip": "",
  "helpUrl": ""
},

//Autres commandes (divers 330)
//----------------

//Utilitaires (divers 330)
//-------------
//degres(angle)
{
  "type": "divers_degres",
  "message0": "degres( %1 )",
  "args0": [
    {
      "type": "input_value",
      "name": "x",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//radians(angle)
{
  "type": "divers_radians",
  "message0": "radians( %1 )",
  "args0": [
    {
      "type": "input_value",
      "name": "x",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//hasard(min, max)
{
  "type": "divers_hasard",
  "message0": "hasard( %1 , %2 )",
  "args0": [
    {
      "type": "input_value",
      "name": "x",
      "check": "Number"
    },
    {
      "type": "input_value",
      "name": "y",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//sinD(angle)
{
  "type": "divers_sinD",
  "message0": "sinD( %1 )",
  "args0": [
    {
      "type": "input_value",
      "name": "x",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//cosD(angle)
{
  "type": "divers_cosD",
  "message0": "cosD( %1 )",
  "args0": [
    {
      "type": "input_value",
      "name": "x",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//tanD(angle)
{
  "type": "divers_tanD",
  "message0": "tanD( %1 )",
  "args0": [
    {
      "type": "input_value",
      "name": "x",
      "check": "Number"
    }
  ],
  "output": "Number",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//alerte(chaine)
{
  "type": "divers_alerte",
  "message0": "fenêtre d'alerte avec %1",
  "args0": [
    {
      "type": "input_value",
      "name": "TEXTE",
      "check": "String"
    }
  ],
  "previousStatement": null,
  "nextStatement": null,
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
//demande(ligne1, ligne2, … , parDéfaut)
{
  "type": "divers_demande",
  "message0": "demande d'information %1 réponse par défaut %2",
  "args0": [
    {
      "type": "input_value",
      "name": "DEMANDE",
      "check": "String"
    },
    {
      "type": "input_value",
      "name": "DEFAUT",
      "check": "String"
    }
  ],
  "output": "String",
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
// Commentaire
{
  "type": "divers_commentaire",
  "message0": "Commentaire %1",
  "args0": [
    {
      "type": "input_value",
      "name": "TEXTE",
      "check": "String"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
},
// Variable locale
{
  "type": "divers_varLocale",
  "message0": "variable locale %1",
  "args0": [
    {
      "type": "input_value",
      "name": "VAR",
      "check": "Number"
    }
  ],
  "inputsInline": true,
  "previousStatement": null,
  "nextStatement": null,
  "colour": 330,
  "tooltip": "",
  "helpUrl": ""
}
]);  // END JSON EXTRACT (Do not delete this comment.)

